#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/types.h>

int
main(int argc, char *argv[])
{
    if (argc != 3) {
	fprintf(stderr, "usage: client-3 <hostname> <port>\n");
	exit(1);
    }

    char *hostname = argv[1];
    int  port      = atoi(argv[2]);

    int fd = socket(AF_INET, SOCK_STREAM, 0);
    assert(fd > -1);

    struct hostent *hp;
    hp = gethostbyname(hostname);
    assert(hp != NULL);

    struct sockaddr_in serveraddr;
    bzero((char *) &serveraddr, sizeof(serveraddr));
    serveraddr.sin_family = AF_INET;
    bcopy((char *) hp->h_addr_list[0],
	  (char *) &serveraddr.sin_addr.s_addr, hp->h_length);
    serveraddr.sin_port = htons(port);

    int rc = connect(fd, (struct sockaddr *) &serveraddr, sizeof(serveraddr));

    // now write something
    char request[1000];
    sprintf(request, "hello server!");
    printf("client: sending request!\n");
    rc = write(fd, request, strlen(request) + 1);
    printf("client: sent request\n");

    char reply[1000];
    rc = read(fd, reply, 1000);
    printf("client: got reply [%d %s]\n", rc, reply);

    close(fd);

    return 0;
}



