#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <assert.h>

// set up connection
int openbindlisten(int port) {
    int fd, optval=1;
    struct sockaddr_in addr;

    // socket descriptor
    fd = socket(AF_INET, SOCK_STREAM, 0);
    assert(fd > -1);
 
    // already in use problem 
    setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, 
	       (const void *) &optval, sizeof(int));

    // bind to listening port
    bzero((char *) &addr, sizeof(addr));
    addr.sin_family      = AF_INET; 
    addr.sin_addr.s_addr = htonl(INADDR_ANY); 
    addr.sin_port        = htons((unsigned short) port); 

    int rc = bind(fd, (struct sockaddr *) &addr, sizeof(addr));
    assert(rc == 0);

    // and now set up the listen
    rc = listen(fd, 1024);
    assert(rc == 0);
    return fd;
}

int main(int argc, char *argv[]) {
    int mainfd, connfd, port, clientlen;
    struct sockaddr_in clientaddr;

    if (argc != 2) {
	fprintf(stderr, "usage: server <port>\n");
	exit(1);
    }

    port = atoi(argv[1]);

    printf("server: listen on port %d\n", port);

    mainfd = openbindlisten(port);

    while (1) {
	printf("server: waiting to accept\n");
	clientlen = sizeof(clientaddr);
	connfd = accept(mainfd, (struct sockaddr *) &clientaddr, 
			(socklen_t *) &clientlen);
	assert(connfd > -1);

	printf("server: accepted connection [%d]\n", connfd);

	char request[1000];
	int rc = read(connfd, request, 1000);
	printf("server: got request [%d %s]\n", rc, request);

	sleep(5);

	char reply[1000];
	sprintf(reply, "hello back!");
	rc = write(connfd, reply, strlen(reply) + 1);

	close(connfd);
    }
    return 0;
}


    


 
